using Nemerle;


namespace Rsdn.ParserTools.Bnf
{
  [Record]
  public variant Node
  {
    public loc : TextLocator;
    
    | Root {
      header : IConstListDictionary[string, Arg];
      ast : IConstListDictionary[string, Constructor];
      subst : IConstListDictionary[string, Rule];
      lexers : IConstListDictionary[string, Section];
      parser : Section; }
    | Constructor { id : string; isfun : bool; args : IConstListDictionary[string, Field]; }
    | Field { id : string; fieldType : string; }
    | Section { args : IConstListDictionary[string, Arg]; body : IConstListDictionary[string, Rule]; }
    | Arg { key : string; value : string; }
    | Rule { subst : bool; id : string; tag : string; expr : Node; }
    | Union { first : Node; second : Node; }
    | Concat { first : Node; second : Node; }
    | Optional { expr : Node; }
    | Closure { expr : Node; }
    | PositiveClosure { expr : Node; }
    | Intersection { first : Node; second : Node; }
    | Difference { first : Node; second : Node; }
    | Complement { expr : Node; }
    | Id { name : string; }
    | Tagged { expr : Node; tag : string; }
    | Range { first : int; second : int; }
    | String { value : string; }
    
    | List { value : list[Node]; }
    | Token
    | Null
  }
}