using Nemerle.Assertions;
using Nemerle.Extensions;
using System;
using System.Collections.Generic;
using System.Text;

namespace Rsdn.ParserTools.Finite
{
  public class Dfa['s]
    where 's : class
  {
    private states : ListSet['s];
    private mutable initial : 's;
    private function : TransitionFunction['s];
    
    public this()
    {
       states = ListSet();
       function = TransitionFunction();
    }
    
    public Initial : 's
    {
      get
      {
        initial
      }
      set requires states.Contains(value)
      {
        initial = value;
      }
    }
    
    public States : IEnumerable['s]
    {
      get
      {
        states
      }
    }
    
    public Transitions : IEnumerable['s * CharRange * 's]
    {
      get
      {
        function.Transitions
      }
    }
    
    public Add(state : 's) : void
    {
      states.Add(state);
    }
    
    public AddTransition(init : 's, cond : CharRange, final : 's) : void
    {
      //when (function.GetTransitions(init, cond).Count > 0)
      //{
        //throw Exception(
          //"Unable to add transition from specified state: transition from this state already exists");
      //}
      function.Add(init, cond, final);
    }
    
    public GetTransition(state : 's, cond : CharRange) : 's
    {
      def transitions = function.GetTransitions(state, cond);
      when (transitions.Count > 1)
      {
        throw Exception("Error: inconsistent DFA");
      }
      if (transitions.Count == 1)
        transitions[0]
      else
        DefaultValue('s)
    }
  }
}