using Nemerle;
using Nemerle.Collections;
using Nemerle.Imperative;
using SCG = System.Collections.Generic;


namespace Rsdn.ParserTools
{
  public class HashSet['a] : SCG.ICollection['a], SCG.IEnumerable['a], System.ICloneable
  {
    data : SCG.Dictionary['a, 'a] = SCG.Dictionary.['a, 'a]();
    mutable needHash = true;
    mutable hashCode = 0;
    
    public this()
    {
    }
    
    public this(init : SCG.IEnumerable['a])
    {
      AddMany(init)
    }
    
    public Count : int
    {
      get
      {
        data.Count
      }
    }
    
    public IsReadOnly : bool
    {
      get
      {
        false
      }
    }
    
    public Add(item : 'a) : void
    {
      unless (data.ContainsKey(item))
      {
        data.Add(item, item);
        needHash = true;
      }
    }
    
    public AddMany(iter : SCG.IEnumerable['a]) : void
    {
      foreach (item when !Contains(item) in iter)
      {
        data.Add(item, item);
        needHash = true
      }
    }
    
    public Clear() : void
    {
      data.Clear();
      needHash = true
    }
    
    public Contains(item : 'a) : bool
    {
      data.ContainsKey(item)
    }
    
    public CopyTo(arr : array['a], arrayIndex : int) : void
    {
      data.Keys.CopyTo(arr, arrayIndex)
    }
    
    public Remove(item : 'a) : bool
    {
      if (data.ContainsKey(item))
      {
        _ = data.Remove(item);
        needHash = true;
        true
      }
      else
        false
    }
    
    public RemoveMany(iter : SCG.IEnumerable['a]) : void
    {
      foreach (item when !Contains(item) in iter)
      {
        _ = data.Remove(item);
        needHash = true
      }
    }
    
    public GetEnumerator() : SCG.IEnumerator['a]
    {
      data.Keys.GetEnumerator()
    }
    
    private GetEnumerator_old() : System.Collections.IEnumerator
      implements System.Collections.IEnumerable.GetEnumerator
    {
      data.Keys.GetEnumerator()
    }
    
    public override Equals(obj : object) : bool
    {
      if (object.ReferenceEquals(this, obj))
        true
      else if(obj is HashSet.['a])
      {
        def other = obj :> HashSet.['a];
        this.Count == other.Count && this <= other
      }
      else
        false
    }
    
    public override GetHashCode() : int
    {
      when (needHash)
      {
        needHash = false;
        hashCode = 12;
        foreach (item in this)
          hashCode ^= item.GetHashCode()
      }
      hashCode
    }
    
    public Clone() : object
    {
      def n = HashSet.['a]();
      foreach (item in this)
        n.Add(item);
      n
    }
    
    public GetOriginal(item : 'a) : 'a
    {
      data[item]
    }

    public UnionWith(other : HashSet['a]) : void
    {
      AddMany(other)
    }
    
    public IntersectionWith(other : HashSet['a]) : void
    {
      def list = Vector.['a]();
      foreach (item in this)
        list.Add(item);
      foreach (item when !other.Contains(item) in list)
          _ = this.Remove(item);
    }
    
    public DifferenceWith(other : HashSet['a]) : void
    {
      RemoveMany(other)
    }
    
    public IntersectsWith(other : HashSet['a]) : bool
    {
      foreach (item in this)
      {
        when (other.Contains(item)) return true;
      }
      false
    }
    
    public IsSubsetOf(other : HashSet['a]) : bool
    {
      if (other.Count < this.Count)
        false
      else
      {
        foreach (item in this)
          unless (other.Contains(item)) return false;
        true
      }
    }
    
    public static @&(a : HashSet['a], b : HashSet['a]) : HashSet['a]
    {
      def r = HashSet(a);
      r.IntersectionWith(b);
      r
    }
    
    public static @|(a : HashSet['a], b : HashSet['a]) : HashSet['a]
    {
      def r = HashSet(a);
      r.UnionWith(b);
      r
    }
    
    public static @-(a : HashSet['a], b : HashSet['a]) : HashSet['a]
    {
      def r = HashSet(a);
      r.DifferenceWith(b);
      r
    }
    
    public static @<-(a : 'a, b : HashSet['a]) : bool
    {
      b.Contains(a)
    }
    
    public static @<=(a : HashSet['a], b : HashSet['a]) : bool
    {
      a.IsSubsetOf(b)
    }
  }
}