using Nemerle;
using Nemerle.Collections;
using Nemerle.Imperative;
using SCG = System.Collections.Generic;


namespace Rsdn.ParserTools
{
  public class ListDictionary['a, 'b] : IConstListDictionary['a, 'b]
  {
    keys : ListSet['a];
    map : SCG.Dictionary['a, 'b];
    
    public this()
    {
      keys = ListSet();
      map = SCG.Dictionary();
    }
    
    public this(init : SCG.IEnumerable['a * 'b])
    {
      keys = ListSet();
      map = SCG.Dictionary();
      foreach ((k, v) in init)
        Add(k, v);
    }
    
    public Item[key : 'a] : 'b
    {
      get
      {
        map[key]
      }
    }
    
    public Count : int
    {
      get
      {
        keys.Count
      }
    }
    
    public Keys : IConstListSet['a]
    {
      get
      {
        keys
      }
    }
    
    public GetEnumerator() : SCG.IEnumerator['a * 'b]
    {
      foreach (pair in map)
        yield (pair.Key, pair.Value);
    }
    
    private GetEnumerator_old() : System.Collections.IEnumerator
      implements System.Collections.IEnumerable.GetEnumerator
    {
      GetEnumerator()
    }
    
    public Add(key : 'a, value : 'b) : void
    {
      keys.Add(key);
      map.Add(key, value);
    }
    
    public Set(key : 'a, value : 'b) : void
    {
      if (keys.Contains(key))
      {
        map[key] = value
      }
      else
      {
        map.Add(key, value)
      }
    }
    
    public ContainsKey(key : 'a) : bool
    {
      map.ContainsKey(key)
    }
    
    // TODO: implement all mutators
  }
}