using Nemerle;
using Nemerle.Collections;
using Nemerle.Imperative;
using Nemerle.Utility;
using SCG = System.Collections.Generic;


namespace Rsdn.ParserTools
{
  public class ListMultiDictionary['a, 'b] : IConstListMultiDictionary['a, 'b]
  {
    static defaultSet : ListSet['b] = ListSet();
    keys : ListSet['a];
    map : SCG.Dictionary['a, ListSet['b]];
    
    public this()
    {
      keys = ListSet();
      map = SCG.Dictionary();
    }
    
    public Item[key : 'a] : IConstListSet['b]
    {
      get
      {
        if (map.ContainsKey(key))
          map[key]
        else
          defaultSet
      }
    }
    
    public Count : int
    {
      get
      {
        this.FoldLeft(0, fun(_, c) { c + 1 })
      }
    }
    
    public Keys : IConstListSet['a]
    {
      get
      {
        keys
      }
    }
    
    public GetEnumerator() : SCG.IEnumerator['b]
    {
      foreach (value in map.Values)
      {
        foreach (item in value)
        {
          yield item
        }
      }
    }
    
    private GetEnumerator_old() : System.Collections.IEnumerator
      implements System.Collections.IEnumerable.GetEnumerator
    {
      GetEnumerator()
    }
    
    public Add(key : 'a, value : 'b) : void
    {
      if (keys.Contains(key))
        map[key].Add(value)
      else
      {
        keys.Add(key);
        def set = ListSet();
        set.Add(value);
        map.Add(key, set);
      }
    }
    
    public AddMany(key : 'a, values : SCG.IEnumerable['b]) : void
    {
      foreach (item in values)
        Add(key, item);
    }
    
    public AddMany(values : SCG.IEnumerable['a * 'b]) : void
    {
      foreach ((a, b) in values)
        Add(a, b);
    }
        
    public static Inverse(source : IConstListMultiDictionary['a, 'b]) : ListMultiDictionary['b, 'a]
    {
      def inv = ListMultiDictionary();
      foreach (key in source.Keys)
        foreach (value in source[key])
          inv.Add(value, key);
      inv
    }
    
    // TODO: implement all mutators
  }
}