using Nemerle;
using Nemerle.Collections;
using Nemerle.Imperative;
using SCG = System.Collections.Generic;


namespace Rsdn.ParserTools
{
  public class ConstListSet['a] : IConstListSet['a]
  {
    set : SCG.Dictionary['a, int]  = SCG.Dictionary.['a, int]();
    lst : Vector['a] = Vector.['a]();
    hash : int;
    
    public this(iter : SCG.IEnumerable['a])
    {
      hash = 58356835;
      foreach (e when !set.ContainsKey(e) in iter)
      {
        set.Add(e, lst.Count);
        lst.Add(e);
        hash ^= e.GetHashCode();
      }
    }
    
    public Item[index : int] : 'a
    {
      get
      {
        lst[index]
      }
    }    
    
    public Count : int
    {
      get
      {
        set.Count
      }
    }
    
    public IndexOf(item : 'a) : int
    {
      if (set.ContainsKey(item))
        set[item]
      else
        -1
    }
    
    public GetOriginal(item : 'a) : 'a
    {
      this[IndexOf(item)]
    }
    
    public GetEnumerator() : SCG.IEnumerator['a]
    {
      lst.GetEnumerator()
    }
    
    private GetEnumerator_old() : System.Collections.IEnumerator
      implements System.Collections.IEnumerable.GetEnumerator
    {
      lst.GetEnumerator()
    }
    
    public override GetHashCode() : int
    {
      hash
    }
    
    [OverrideObjectEquals]
    public Equals(other : ConstListSet['a]) : bool
    {
      this == other
    }
    
    public static @==(a : ConstListSet['a], b : ConstListSet['a]) : bool
    {
      when (object.ReferenceEquals(a, b)) return true;
      when (a.Count != b.Count) return false;
      foreach (e in a)
        unless (b.Contains(e)) return false;
      true
    }
    
    public static @!=(a : ConstListSet['a], b : ConstListSet['a]) : bool
    {
      !(a == b)
    }
  }
  
  public class ListSet['a] : IConstListSet['a]
  {
    set : SCG.Dictionary['a, int]  = SCG.Dictionary.['a, int]();
    lst : Vector['a] = Vector.['a]();
    
    public this()
    {
    }
    
    public this(init : SCG.IEnumerable['a])
    {
      foreach (item when !set.ContainsKey(item) in init)
      {
        set.Add(item, lst.Count);
        lst.Add(item)
      }
    }
    
    public Add(item : 'a) : void
    {
      unless (set.ContainsKey(item))
      {
        set.Add(item, lst.Count);
        lst.Add(item)
      }
    }
    
    public AddMany(items : SCG.IEnumerable['a]) : void
    {
      foreach (item in items)
        Add(item);
    }
    
    public Item[index : int] : 'a
    {
      get
      {
        lst[index]
      }
    }    
    
    public Count : int
    {
      get
      {
        set.Count
      }
    }
    
    public IndexOf(item : 'a) : int
    {
      if (set.ContainsKey(item))
        set[item]
      else
        -1
    }
    
    public GetEnumerator() : SCG.IEnumerator['a]
    {
      lst.GetEnumerator()
    }
    
    private GetEnumerator_old() : System.Collections.IEnumerator
      implements System.Collections.IEnumerable.GetEnumerator
    {
      lst.GetEnumerator()
    }
    
    // TODO: Implement all mutators
  }
}