using Nemerle;

namespace Rsdn.ParserTools
{
  public variant RegexpNode
  {
    | Concat { first : RegexpNode; second : RegexpNode; }
    | Union { first : RegexpNode; second : RegexpNode; }
    | Closure { expr : RegexpNode; }
    | Range { value : CharRange; }
    | Empty
    
    public override ToString() : string
    {
      def rstr(node)
      {
        | RegexpNode.Concat(a, b) => $"($(rstr(a)) $(rstr(b)))"
        | RegexpNode.Union(a, b) => $"($(rstr(a)) | $(rstr(b)))"
        | RegexpNode.Closure(a) => $"($(rstr(a)))*"
        | RegexpNode.Range(_) => "r"
        | RegexpNode.Empty() => "'e"
      }
      rstr(this)
    }
  }
}