﻿using Nemerle;
using System;
using System.Text;


namespace Rsdn.ParserTools
{
  class MacroErrorLog : IErrorLog
  {
    mutable panic = false;
    
    public Message(error : Error) : void
    {
      def loc = Nemerle.Compiler.Location(
        error.Locator.Url,
        error.Locator.First.Row, error.Locator.First.Column,
        error.Locator.Last.Row, error.Locator.Last.Column);
      match (error.ErrorLevel)
      {
        | ErrorLevel.Error =>
          Nemerle.Compiler.Message.Error(loc, error.Message)
        | ErrorLevel.Warning =>
          Nemerle.Compiler.Message.Warning(loc, error.Message)
        | ErrorLevel.Hint
        | ErrorLevel.Info =>
          Nemerle.Compiler.Message.Hint(loc, error.Message)
      }
      Console.WriteLine(error.Message);
    }
    
    public SetPanic() : void
    {
      panic = true;
    }
    
    public Panic : bool
    {
      get
      {
        panic
      }
    }
    
    public HasErrors : bool
    {
      get
      {
        Nemerle.Compiler.Message.SeenError
      }
    }
  }
}