using Nemerle;
using Nemerle.Collections;
using Nemerle.Utility;
using System;


namespace Rsdn.ParserTools.Test
{
  [Record]
  public variant Node
  {
    loc : TextLocator;
    | Function { id : string; args : list[Node]; }
    | Id { name : string; }
    | Number { value : float; }
    | List { value : list[Node]; }
    | Token { token : TokenType; }
    | Null
    
    public override ToString() : string
    {
      match (this)
      {
        | Function(id, args) =>
          def v = List.Map(args, fun(x) { x.ToString() });
          def args_str = NString.Concat(" ", v);
          $"($id $args_str)"
        | Id(name) => name
        | Number(value) => value.ToString()
        | List(value) => value.ToString();
        | Token(t) => t.ToString();
        | Null() => "_null_";
        | _ => "_unknown_"
      }
    }
  }
}